// Generated by CoffeeScript 1.9.1
(function() {
  var PrologDb, async, pengines, qs, simpleAuth,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  qs = require('qs');

  pengines = require('pengines');

  simpleAuth = require('./simpleAuth');

  async = require('async');

  PrologDb = (function() {
    var openQueries;

    openQueries = {};

    function PrologDb(options) {
      this.openQuery = bind(this.openQuery, this);
      this.query = bind(this.query, this);
      this.open = bind(this.open, this);
      this.authOptions = options.authOptions, this.applicationName = options.applicationName, this.serverUrl = options.serverUrl, this.maxQueryLength = options.maxQueryLength, this.sourceText = options.sourceText;
      if (this.maxQueryLength == null) {
        this.maxQueryLength = 1000;
      }
      if (this.applicationName == null) {
        this.applicationName = "swish";
      }
      if (this.sourceText == null) {
        this.sourceText = "";
      }
    }

    PrologDb.prototype.open = function(callback) {
      if (this.authOptions != null) {
        return simpleAuth(this.authOptions, (function(_this) {
          return function() {
            var cookieJar, error;
            error = arguments[0], cookieJar = arguments[arguments.length - 1];
            _this.cookieJar = cookieJar;
            return callback(error, _this);
          };
        })(this));
      } else {
        this.cookieJar = request.jar();
        return callback(null, this);
      }
    };

    PrologDb.prototype.addPresetSourceText = function(sourceText, callback) {
      return this.sourceText = this.sourceText != null ? this.sourceText + "\n" + fileContent : sourceText;
    };

    PrologDb.connect = function(options, callback) {
      return new PrologDb(options).open((function(_this) {
        return function(error, newPrologDb) {
          return callback(error, newPrologDb);
        };
      })(this));
    };

    PrologDb.prototype.query = function(queryString, callback) {
      var peng, pengineOptions, queryResult;
      pengineOptions = {
        server: this.serverUrl,
        application: this.applicationName,
        format: "json",
        destroy: true,
        sourceText: this.sourceText,
        ask: queryString,
        chunk: this.maxQueryLength,
        cookieJar: this.cookieJar
      };
      queryResult = null;
      return peng = pengines(pengineOptions).on('error', function(obj) {
        return callback(new Error("Error in operation: " + obj.data));
      }).on('failure', function(error) {
        return callback(new Error("Pengine object failed: " + obj.data));
      }).on('destroy', function() {
        return callback(null, queryResult);
      }).on('success', function(result) {
        queryResult = result;
        return peng.destroy();
      });
    };

    PrologDb.prototype.queryMore = function(queryId, callback) {
      var openQuery;
      openQuery = openQueries[queryId];
      if (callback == null) {
        callback = openQuery.initialCallback;
      }
      openQuery.once('success', function(result) {
        return callback(null, result, queryId);
      });
      return openQuery.next();
    };

    PrologDb.prototype.closeQuery = function(queryId, callback) {
      return openQueries[queryId].destroy().on('destroy', callback);
    };

    PrologDb.prototype.openQuery = function(queryString, nEntries, callback) {
      var peng;
      return peng = pengines({
        server: this.serverUrl,
        application: this.applicationName,
        format: "json",
        destroy: false,
        sourceText: this.sourceText,
        ask: queryString,
        chunk: nEntries,
        cookieJar: this.cookieJar
      }).on('error', function(obj) {
        return callback(new Error("Error in operation: " + obj.data));
      }).on('failure', function(obj) {
        return callback(new Error("Pengine object failed: " + (JSON.stringify(obj))));
      }).on('create', function(result) {
        openQueries[peng.id] = peng;
        return openQueries[peng.id].initialCallback = callback;
      }).once('success', function(result) {
        return callback(null, result, peng.id);
      });
    };

    PrologDb.cleanUp = function() {
      var id, peng, results;
      results = [];
      for (id in openQueries) {
        peng = openQueries[id];
        if (peng.died) {
          results.push(delete openQueries[id]);
        } else {
          results.push(peng.destroy());
        }
      }
      return results;
    };

    return PrologDb;

  })();

  process.on('exit', function(code) {
    return PrologDb.cleanUp();
  });

  module.exports = PrologDb;

}).call(this);
