fs = require 'fs'
async = require 'async'


_ = require 'underscore'


prologDb = require './../src/prolog-db'

tests =
    
    
    setUp : (callback) ->
        @opts = {
            authOptions: {
                url: 'http://localhost:3020/servlets/login',
                username: "admin",
                password: "adminadmin"
            },
            applicationName: "mash",
            serverUrl: "http://localhost:3020/pengine",
            sourceText: "is_a_program(Object) :-
                            rdf(Object,rdf:'type',vusion:'database'),
                            rdf(Object,vusion:'hasParticipants',_).\n\n
                        undefined_predicate(P) :-
                            rdf_current_predicate(P),
                            (   rdf(_,P,_)
                            ->  not(rdf(P,_,_))
                            ).
                        "
            }
    
        @pdb = new prologDb(@opts)
        
        @pdb.open (error, newPdb) =>
            callback()
    
    
    connect : (test) ->
        test.expect(1)
        prologDb.connect @opts, (error,newPdb) =>
            test.ok(not error,"Performed connect")
            test.done()
        

        
        
    
        
        
    
    openVsInstantQuery : (test) ->
        

        
        queryStrings = ["rdf(A,B,C)", "undefined_predicate(A)", "rdf(A,B,C)", "rdf(A,B,C)", "rdf(A,B,C)", "rdf(A,B,C)"]

        noOpenQueryResults = 10
        
        test.expect((noOpenQueryResults+2)*queryStrings.length)

        

        async.eachSeries(queryStrings,( (queryString,callback) =>
            totalResult = []
            counter = 0
            #console.log "new", queryString
            @pdb.openQuery queryString,1,(error,result,queryId) =>
                
                test.ok(not error?, "openQuery database using custom predicate (#{counter})")
                console.log error
                totalResult.push(result.data[0])

                if ++counter < noOpenQueryResults
                    
                    @pdb.queryMore(queryId)
                    
                else
                    @pdb.closeQuery(queryId, =>
                        #destroyCallback()
                        #Continue with tests
                        #console.log "Done with open query"

                        @pdb.maxQueryLength = noOpenQueryResults



                        @pdb.query queryString,(error,result) =>

                            test.ok(not error, "normal query with custom predicate")


                            #test.ok(not error, "normal query with custom predicate")

                            arrayEqual = (a, b) ->
                                a.length is b.length and a.every (elem, i) -> _.isEqual(elem,b[i])


                            test.ok(arrayEqual(result.data,totalResult),"both ways of querying return the same result")



                            #return test.done()
                            return callback()
                    )
                ), (error) ->
                    test.done()
                    
        )

    adminRightsOperation : (test) ->
        test.expect(2)
        
        @pdb.query("rdf_assert(cat,likes,balls)", (error,result) =>
            test.ok(not error and result.event == "success","Assert succeeded")
            #test.done()
            
            @pdb.query("rdf_assert(cat,likes,balls)", (error,result) =>
                test.ok(not error and result.event == "success","Assert succeeded")
                test.done())
            
        )

        
        
        
        
                    


                    
                
            

                
    
module.exports = tests
